/* dict.c generated by valac 0.56.14, the Vala compiler
 * generated from dict.vala, do not modify */

/*
 * Copyright (C) 2011-2018 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "libskk/libskk.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

enum  {
	SKK_DICT_0_PROPERTY,
	SKK_DICT_READ_ONLY_PROPERTY,
	SKK_DICT_NUM_PROPERTIES
};
static GParamSpec* skk_dict_properties[SKK_DICT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SKK_EMPTY_DICT_0_PROPERTY,
	SKK_EMPTY_DICT_READ_ONLY_PROPERTY,
	SKK_EMPTY_DICT_NUM_PROPERTIES
};
static GParamSpec* skk_empty_dict_properties[SKK_EMPTY_DICT_NUM_PROPERTIES];

#define SKK_TYPE_SKK_DICT_ERROR (skk_skk_dict_error_get_type ())

typedef enum  {
	SKK_SKK_DICT_ERROR_NOT_READABLE,
	SKK_SKK_DICT_ERROR_MALFORMED_INPUT
} SkkSkkDictError;
#define SKK_SKK_DICT_ERROR skk_skk_dict_error_quark ()

static gpointer skk_dict_parent_class = NULL;
static gpointer skk_empty_dict_parent_class = NULL;

static void skk_dict_real_reload (SkkDict* self,
                           GError** error);
static SkkCandidate** skk_dict_real_lookup (SkkDict* self,
                                     const gchar* midasi,
                                     gboolean okuri,
                                     gint* result_length1);
static gchar** skk_dict_real_complete (SkkDict* self,
                                const gchar* midasi,
                                gint* result_length1);
static gboolean skk_dict_real_select_candidate (SkkDict* self,
                                         SkkCandidate* candidate);
static gboolean skk_dict_real_purge_candidate (SkkDict* self,
                                        SkkCandidate* candidate);
static void skk_dict_real_save (SkkDict* self,
                         GError** error);
static GType skk_dict_get_type_once (void);
static void _vala_skk_dict_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void skk_empty_dict_real_reload (SkkDict* base,
                                 GError** error);
static SkkCandidate** skk_empty_dict_real_lookup (SkkDict* base,
                                           const gchar* midasi,
                                           gboolean okuri,
                                           gint* result_length1);
static gchar** skk_empty_dict_real_complete (SkkDict* base,
                                      const gchar* midasi,
                                      gint* result_length1);
static GType skk_empty_dict_get_type_once (void);
static void _vala_skk_empty_dict_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
VALA_EXTERN GQuark skk_skk_dict_error_quark (void);
VALA_EXTERN GType skk_skk_dict_error_get_type (void) G_GNUC_CONST ;
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
         * Parse a line consisting of candidates separated by "/".
         *
         * @param line a line consisting of candidates
         * @return an array of Candidates
         */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 131 "dict.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1491 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1492 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1492 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1492 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1493 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		start = string_length + start;
#line 158 "dict.c"
	}
#line 1496 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		end = string_length + end;
#line 164 "dict.c"
	}
#line 1499 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 170 "dict.c"
	} else {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 174 "dict.c"
	}
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1500 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 182 "dict.c"
	} else {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 186 "dict.c"
	}
#line 1500 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1502 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1502 "glib-2.0.vapi"
	result = _tmp4_;
#line 1502 "glib-2.0.vapi"
	return result;
#line 198 "dict.c"
}

SkkCandidate**
skk_dict_split_candidates (SkkDict* self,
                           const gchar* midasi,
                           gboolean okuri,
                           const gchar* line,
                           gint* result_length1)
{
	gchar** strv = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint strv_length1;
	gint _strv_size_;
	SkkCandidate** candidates = NULL;
	gchar** _tmp7_;
	gint _tmp7__length1;
	SkkCandidate** _tmp8_;
	gint candidates_length1;
	gint _candidates_size_;
	SkkCandidate** _tmp30_;
	gint _tmp30__length1;
	SkkCandidate** result;
#line 29 "dict.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "dict.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 29 "dict.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 33 "dict.vala"
	_tmp0_ = string_strip (line);
#line 33 "dict.vala"
	_tmp1_ = _tmp0_;
#line 33 "dict.vala"
	_tmp2_ = string_slice (_tmp1_, (glong) 1, (glong) -1);
#line 33 "dict.vala"
	_tmp3_ = _tmp2_;
#line 33 "dict.vala"
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, "/", 0);
#line 33 "dict.vala"
	_tmp6_ = _tmp5_;
#line 33 "dict.vala"
	_tmp6__length1 = _vala_array_length (_tmp4_);
#line 33 "dict.vala"
	_g_free0 (_tmp3_);
#line 33 "dict.vala"
	_g_free0 (_tmp1_);
#line 33 "dict.vala"
	strv = _tmp6_;
#line 33 "dict.vala"
	strv_length1 = _tmp6__length1;
#line 33 "dict.vala"
	_strv_size_ = strv_length1;
#line 34 "dict.vala"
	_tmp7_ = strv;
#line 34 "dict.vala"
	_tmp7__length1 = strv_length1;
#line 34 "dict.vala"
	_tmp8_ = g_new0 (SkkCandidate*, _tmp7__length1 + 1);
#line 34 "dict.vala"
	candidates = _tmp8_;
#line 34 "dict.vala"
	candidates_length1 = _tmp7__length1;
#line 34 "dict.vala"
	_candidates_size_ = candidates_length1;
#line 270 "dict.c"
	{
		gint i = 0;
#line 35 "dict.vala"
		i = 0;
#line 275 "dict.c"
		{
			gboolean _tmp9_ = FALSE;
#line 35 "dict.vala"
			_tmp9_ = TRUE;
#line 35 "dict.vala"
			while (TRUE) {
#line 282 "dict.c"
				gchar** _tmp11_;
				gint _tmp11__length1;
				gchar** text_annotation = NULL;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gchar** _tmp14_;
				gchar** _tmp15_;
				gint text_annotation_length1;
				gint _text_annotation_size_;
				gchar* text = NULL;
				gchar* annotation = NULL;
				gchar** _tmp16_;
				gint _tmp16__length1;
				SkkCandidate** _tmp26_;
				gint _tmp26__length1;
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				SkkCandidate* _tmp29_;
#line 35 "dict.vala"
				if (!_tmp9_) {
#line 304 "dict.c"
					gint _tmp10_;
#line 35 "dict.vala"
					_tmp10_ = i;
#line 35 "dict.vala"
					i = _tmp10_ + 1;
#line 310 "dict.c"
				}
#line 35 "dict.vala"
				_tmp9_ = FALSE;
#line 35 "dict.vala"
				_tmp11_ = strv;
#line 35 "dict.vala"
				_tmp11__length1 = strv_length1;
#line 35 "dict.vala"
				if (!(i < _tmp11__length1)) {
#line 35 "dict.vala"
					break;
#line 322 "dict.c"
				}
#line 36 "dict.vala"
				_tmp12_ = strv;
#line 36 "dict.vala"
				_tmp12__length1 = strv_length1;
#line 36 "dict.vala"
				_tmp13_ = _tmp12_[i];
#line 36 "dict.vala"
				_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, ";", 2);
#line 36 "dict.vala"
				text_annotation = _tmp15_;
#line 36 "dict.vala"
				text_annotation_length1 = _vala_array_length (_tmp14_);
#line 36 "dict.vala"
				_text_annotation_size_ = text_annotation_length1;
#line 38 "dict.vala"
				_tmp16_ = text_annotation;
#line 38 "dict.vala"
				_tmp16__length1 = text_annotation_length1;
#line 38 "dict.vala"
				if (_tmp16__length1 == 2) {
#line 344 "dict.c"
					gchar** _tmp17_;
					gint _tmp17__length1;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					gchar** _tmp20_;
					gint _tmp20__length1;
					const gchar* _tmp21_;
					gchar* _tmp22_;
#line 39 "dict.vala"
					_tmp17_ = text_annotation;
#line 39 "dict.vala"
					_tmp17__length1 = text_annotation_length1;
#line 39 "dict.vala"
					_tmp18_ = _tmp17_[0];
#line 39 "dict.vala"
					_tmp19_ = g_strdup (_tmp18_);
#line 39 "dict.vala"
					_g_free0 (text);
#line 39 "dict.vala"
					text = _tmp19_;
#line 40 "dict.vala"
					_tmp20_ = text_annotation;
#line 40 "dict.vala"
					_tmp20__length1 = text_annotation_length1;
#line 40 "dict.vala"
					_tmp21_ = _tmp20_[1];
#line 40 "dict.vala"
					_tmp22_ = g_strdup (_tmp21_);
#line 40 "dict.vala"
					_g_free0 (annotation);
#line 40 "dict.vala"
					annotation = _tmp22_;
#line 377 "dict.c"
				} else {
					gchar** _tmp23_;
					gint _tmp23__length1;
					const gchar* _tmp24_;
					gchar* _tmp25_;
#line 42 "dict.vala"
					_tmp23_ = strv;
#line 42 "dict.vala"
					_tmp23__length1 = strv_length1;
#line 42 "dict.vala"
					_tmp24_ = _tmp23_[i];
#line 42 "dict.vala"
					_tmp25_ = g_strdup (_tmp24_);
#line 42 "dict.vala"
					_g_free0 (text);
#line 42 "dict.vala"
					text = _tmp25_;
#line 43 "dict.vala"
					_g_free0 (annotation);
#line 43 "dict.vala"
					annotation = NULL;
#line 399 "dict.c"
				}
#line 45 "dict.vala"
				_tmp26_ = candidates;
#line 45 "dict.vala"
				_tmp26__length1 = candidates_length1;
#line 45 "dict.vala"
				_tmp27_ = text;
#line 45 "dict.vala"
				_tmp28_ = annotation;
#line 45 "dict.vala"
				_tmp29_ = skk_candidate_new (midasi, okuri, _tmp27_, _tmp28_, NULL);
#line 45 "dict.vala"
				_g_object_unref0 (_tmp26_[i]);
#line 45 "dict.vala"
				_tmp26_[i] = _tmp29_;
#line 35 "dict.vala"
				_g_free0 (annotation);
#line 35 "dict.vala"
				_g_free0 (text);
#line 35 "dict.vala"
				text_annotation = (_vala_array_free (text_annotation, text_annotation_length1, (GDestroyNotify) g_free), NULL);
#line 421 "dict.c"
			}
		}
	}
#line 50 "dict.vala"
	_tmp30_ = candidates;
#line 50 "dict.vala"
	_tmp30__length1 = candidates_length1;
#line 50 "dict.vala"
	if (result_length1) {
#line 50 "dict.vala"
		*result_length1 = _tmp30__length1;
#line 433 "dict.c"
	}
#line 50 "dict.vala"
	result = _tmp30_;
#line 50 "dict.vala"
	strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 50 "dict.vala"
	return result;
#line 441 "dict.c"
}

/**
         * Format an array of Candidates to be saved in a dictionary file.
         *
         * @param candidates an array of Candidate
         * @return a string
         */
static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 461 "dict.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 465 "dict.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 471 "dict.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 476 "dict.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 482 "dict.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 486 "dict.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 490 "dict.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 494 "dict.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 498 "dict.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 502 "dict.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 517 "dict.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 526 "dict.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 533 "dict.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 539 "dict.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 547 "dict.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 551 "dict.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 557 "dict.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 562 "dict.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 568 "dict.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 572 "dict.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 576 "dict.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 582 "dict.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 588 "dict.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 600 "dict.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 604 "dict.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 608 "dict.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 613 "dict.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 621 "dict.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 639 "dict.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 645 "dict.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 649 "dict.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 657 "dict.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 666 "dict.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 675 "dict.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 681 "dict.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 689 "dict.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 701 "dict.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 707 "dict.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 711 "dict.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 719 "dict.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 730 "dict.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 739 "dict.c"
	}
}

gchar*
skk_dict_join_candidates (SkkDict* self,
                          SkkCandidate** candidates,
                          gint candidates_length1)
{
	gchar** strv = NULL;
	gchar** _tmp0_;
	gint strv_length1;
	gint _strv_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* result;
#line 59 "dict.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "dict.vala"
	_tmp0_ = g_new0 (gchar*, candidates_length1 + 1);
#line 60 "dict.vala"
	strv = _tmp0_;
#line 60 "dict.vala"
	strv_length1 = candidates_length1;
#line 60 "dict.vala"
	_strv_size_ = strv_length1;
#line 771 "dict.c"
	{
		gint i = 0;
#line 61 "dict.vala"
		i = 0;
#line 776 "dict.c"
		{
			gboolean _tmp1_ = FALSE;
#line 61 "dict.vala"
			_tmp1_ = TRUE;
#line 61 "dict.vala"
			while (TRUE) {
#line 783 "dict.c"
				gchar** _tmp3_;
				gint _tmp3__length1;
				SkkCandidate* _tmp4_;
				gchar* _tmp5_;
#line 61 "dict.vala"
				if (!_tmp1_) {
#line 790 "dict.c"
					gint _tmp2_;
#line 61 "dict.vala"
					_tmp2_ = i;
#line 61 "dict.vala"
					i = _tmp2_ + 1;
#line 796 "dict.c"
				}
#line 61 "dict.vala"
				_tmp1_ = FALSE;
#line 61 "dict.vala"
				if (!(i < candidates_length1)) {
#line 61 "dict.vala"
					break;
#line 804 "dict.c"
				}
#line 62 "dict.vala"
				_tmp3_ = strv;
#line 62 "dict.vala"
				_tmp3__length1 = strv_length1;
#line 62 "dict.vala"
				_tmp4_ = candidates[i];
#line 62 "dict.vala"
				_tmp5_ = skk_candidate_to_string (_tmp4_);
#line 62 "dict.vala"
				_g_free0 (_tmp3_[i]);
#line 62 "dict.vala"
				_tmp3_[i] = _tmp5_;
#line 818 "dict.c"
			}
		}
	}
#line 64 "dict.vala"
	_tmp6_ = strv;
#line 64 "dict.vala"
	_tmp6__length1 = strv_length1;
#line 64 "dict.vala"
	_tmp7_ = _vala_g_strjoinv ("/", _tmp6_, (gint) _tmp6__length1);
#line 64 "dict.vala"
	_tmp8_ = _tmp7_;
#line 64 "dict.vala"
	_tmp9_ = g_strconcat ("/", _tmp8_, NULL);
#line 64 "dict.vala"
	_tmp10_ = _tmp9_;
#line 64 "dict.vala"
	_tmp11_ = g_strconcat (_tmp10_, "/", NULL);
#line 64 "dict.vala"
	_tmp12_ = _tmp11_;
#line 64 "dict.vala"
	_g_free0 (_tmp10_);
#line 64 "dict.vala"
	_g_free0 (_tmp8_);
#line 64 "dict.vala"
	result = _tmp12_;
#line 64 "dict.vala"
	strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 64 "dict.vala"
	return result;
#line 848 "dict.c"
}

/**
         * Reload the dictionary.
         *
         * @throws GLib.Error when reading the dictionary failed.
         */
static void
skk_dict_real_reload (SkkDict* self,
                      GError** error)
{
#line 72 "dict.vala"
	g_critical ("Type `%s' does not implement abstract method `skk_dict_reload'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 72 "dict.vala"
	return;
#line 864 "dict.c"
}

void
skk_dict_reload (SkkDict* self,
                 GError** error)
{
	SkkDictClass* _klass_;
#line 72 "dict.vala"
	g_return_if_fail (self != NULL);
#line 72 "dict.vala"
	_klass_ = SKK_DICT_GET_CLASS (self);
#line 72 "dict.vala"
	if (_klass_->reload) {
#line 72 "dict.vala"
		_klass_->reload (self, error);
#line 880 "dict.c"
	}
}

/**
         * Lookup candidates in the dictionary.
         *
         * @param midasi a midasi (title) string to lookup
         * @param okuri whether to search okuri-ari entries or
         * okuri-nasi entries
         *
         * @return an array of Candidate
         */
static SkkCandidate**
skk_dict_real_lookup (SkkDict* self,
                      const gchar* midasi,
                      gboolean okuri,
                      gint* result_length1)
{
#line 83 "dict.vala"
	g_critical ("Type `%s' does not implement abstract method `skk_dict_lookup'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 83 "dict.vala"
	return NULL;
#line 903 "dict.c"
}

SkkCandidate**
skk_dict_lookup (SkkDict* self,
                 const gchar* midasi,
                 gboolean okuri,
                 gint* result_length1)
{
	SkkDictClass* _klass_;
#line 83 "dict.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "dict.vala"
	_klass_ = SKK_DICT_GET_CLASS (self);
#line 83 "dict.vala"
	if (_klass_->lookup) {
#line 83 "dict.vala"
		return _klass_->lookup (self, midasi, okuri, result_length1);
#line 921 "dict.c"
	}
#line 83 "dict.vala"
	return NULL;
#line 925 "dict.c"
}

/**
         * Return an array of strings which matches midasi.
         *
         * @param midasi a midasi (title) string to lookup
         *
         * @return an array of strings
         */
static gchar**
skk_dict_real_complete (SkkDict* self,
                        const gchar* midasi,
                        gint* result_length1)
{
#line 92 "dict.vala"
	g_critical ("Type `%s' does not implement abstract method `skk_dict_complete'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 92 "dict.vala"
	return NULL;
#line 944 "dict.c"
}

gchar**
skk_dict_complete (SkkDict* self,
                   const gchar* midasi,
                   gint* result_length1)
{
	SkkDictClass* _klass_;
#line 92 "dict.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 92 "dict.vala"
	_klass_ = SKK_DICT_GET_CLASS (self);
#line 92 "dict.vala"
	if (_klass_->complete) {
#line 92 "dict.vala"
		return _klass_->complete (self, midasi, result_length1);
#line 961 "dict.c"
	}
#line 92 "dict.vala"
	return NULL;
#line 965 "dict.c"
}

/**
         * Select a candidate in the dictionary.
         *
         * @param candidate an Candidate
         *
         * @return `true` if the dictionary is modified, `false` otherwise.
         */
static gboolean
skk_dict_real_select_candidate (SkkDict* self,
                                SkkCandidate* candidate)
{
	gboolean result;
#line 106 "dict.vala"
	g_return_val_if_fail (candidate != NULL, FALSE);
#line 109 "dict.vala"
	result = FALSE;
#line 109 "dict.vala"
	return result;
#line 986 "dict.c"
}

gboolean
skk_dict_select_candidate (SkkDict* self,
                           SkkCandidate* candidate)
{
	SkkDictClass* _klass_;
#line 106 "dict.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 106 "dict.vala"
	_klass_ = SKK_DICT_GET_CLASS (self);
#line 106 "dict.vala"
	if (_klass_->select_candidate) {
#line 106 "dict.vala"
		return _klass_->select_candidate (self, candidate);
#line 1002 "dict.c"
	}
#line 106 "dict.vala"
	return FALSE;
#line 1006 "dict.c"
}

/**
         * Purge a candidate in the dictionary.
         *
         * @param candidate an Candidate
         *
         * @return `true` if the dictionary is modified, `false` otherwise.
         */
static gboolean
skk_dict_real_purge_candidate (SkkDict* self,
                               SkkCandidate* candidate)
{
	gboolean result;
#line 119 "dict.vala"
	g_return_val_if_fail (candidate != NULL, FALSE);
#line 122 "dict.vala"
	result = FALSE;
#line 122 "dict.vala"
	return result;
#line 1027 "dict.c"
}

gboolean
skk_dict_purge_candidate (SkkDict* self,
                          SkkCandidate* candidate)
{
	SkkDictClass* _klass_;
#line 119 "dict.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 119 "dict.vala"
	_klass_ = SKK_DICT_GET_CLASS (self);
#line 119 "dict.vala"
	if (_klass_->purge_candidate) {
#line 119 "dict.vala"
		return _klass_->purge_candidate (self, candidate);
#line 1043 "dict.c"
	}
#line 119 "dict.vala"
	return FALSE;
#line 1047 "dict.c"
}

/**
         * Save the dictionary on disk.
         *
         * @throws GLib.Error if the dictionary cannot be saved.
         */
static void
skk_dict_real_save (SkkDict* self,
                    GError** error)
{
}

void
skk_dict_save (SkkDict* self,
               GError** error)
{
	SkkDictClass* _klass_;
#line 130 "dict.vala"
	g_return_if_fail (self != NULL);
#line 130 "dict.vala"
	_klass_ = SKK_DICT_GET_CLASS (self);
#line 130 "dict.vala"
	if (_klass_->save) {
#line 130 "dict.vala"
		_klass_->save (self, error);
#line 1074 "dict.c"
	}
}

SkkDict*
skk_dict_construct (GType object_type)
{
	SkkDict * self = NULL;
#line 22 "dict.vala"
	self = (SkkDict*) g_object_new (object_type, NULL);
#line 22 "dict.vala"
	return self;
#line 1086 "dict.c"
}

gboolean
skk_dict_get_read_only (SkkDict* self)
{
	SkkDictClass* _klass_;
#line 97 "dict.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 97 "dict.vala"
	_klass_ = SKK_DICT_GET_CLASS (self);
#line 97 "dict.vala"
	if (_klass_->get_read_only) {
#line 97 "dict.vala"
		return _klass_->get_read_only (self);
#line 1101 "dict.c"
	}
#line 97 "dict.vala"
	return FALSE;
#line 1105 "dict.c"
}

static void
skk_dict_class_init (SkkDictClass * klass,
                     gpointer klass_data)
{
#line 22 "dict.vala"
	skk_dict_parent_class = g_type_class_peek_parent (klass);
#line 22 "dict.vala"
	((SkkDictClass *) klass)->reload = (void (*) (SkkDict*, GError**)) skk_dict_real_reload;
#line 22 "dict.vala"
	((SkkDictClass *) klass)->lookup = (SkkCandidate** (*) (SkkDict*, const gchar*, gboolean, gint*)) skk_dict_real_lookup;
#line 22 "dict.vala"
	((SkkDictClass *) klass)->complete = (gchar** (*) (SkkDict*, const gchar*, gint*)) skk_dict_real_complete;
#line 22 "dict.vala"
	((SkkDictClass *) klass)->select_candidate = (gboolean (*) (SkkDict*, SkkCandidate*)) skk_dict_real_select_candidate;
#line 22 "dict.vala"
	((SkkDictClass *) klass)->purge_candidate = (gboolean (*) (SkkDict*, SkkCandidate*)) skk_dict_real_purge_candidate;
#line 22 "dict.vala"
	((SkkDictClass *) klass)->save = (void (*) (SkkDict*, GError**)) skk_dict_real_save;
#line 22 "dict.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_skk_dict_get_property;
#line 1128 "dict.c"
	/**
	         * Flag to indicate whether the dictionary is read only.
	         */
#line 22 "dict.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_DICT_READ_ONLY_PROPERTY, skk_dict_properties[SKK_DICT_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1134 "dict.c"
}

static void
skk_dict_instance_init (SkkDict * self,
                        gpointer klass)
{
}

/**
     * Base abstract class of dictionaries.
     */
static GType
skk_dict_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SkkDictClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_dict_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkDict), 0, (GInstanceInitFunc) skk_dict_instance_init, NULL };
	GType skk_dict_type_id;
	skk_dict_type_id = g_type_register_static (G_TYPE_OBJECT, "SkkDict", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return skk_dict_type_id;
}

GType
skk_dict_get_type (void)
{
	static volatile gsize skk_dict_type_id__once = 0;
	if (g_once_init_enter (&skk_dict_type_id__once)) {
		GType skk_dict_type_id;
		skk_dict_type_id = skk_dict_get_type_once ();
		g_once_init_leave (&skk_dict_type_id__once, skk_dict_type_id);
	}
	return skk_dict_type_id__once;
}

static void
_vala_skk_dict_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	SkkDict * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_DICT, SkkDict);
#line 22 "dict.vala"
	switch (property_id) {
#line 1177 "dict.c"
		default:
#line 22 "dict.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "dict.vala"
		break;
#line 1183 "dict.c"
	}
}

/**
         * {@inheritDoc}
         */
static void
skk_empty_dict_real_reload (SkkDict* base,
                            GError** error)
{
	SkkEmptyDict * self;
#line 142 "dict.vala"
	self = (SkkEmptyDict*) base;
#line 1197 "dict.c"
}

/**
         * {@inheritDoc}
         */
static SkkCandidate**
skk_empty_dict_real_lookup (SkkDict* base,
                            const gchar* midasi,
                            gboolean okuri,
                            gint* result_length1)
{
	SkkEmptyDict * self;
	SkkCandidate** _tmp0_;
	SkkCandidate** _tmp1_;
	gint _tmp1__length1;
	SkkCandidate** result;
#line 148 "dict.vala"
	self = (SkkEmptyDict*) base;
#line 148 "dict.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 149 "dict.vala"
	_tmp0_ = g_new0 (SkkCandidate*, 0 + 1);
#line 149 "dict.vala"
	_tmp1_ = _tmp0_;
#line 149 "dict.vala"
	_tmp1__length1 = 0;
#line 149 "dict.vala"
	if (result_length1) {
#line 149 "dict.vala"
		*result_length1 = _tmp1__length1;
#line 1228 "dict.c"
	}
#line 149 "dict.vala"
	result = _tmp1_;
#line 149 "dict.vala"
	return result;
#line 1234 "dict.c"
}

/**
         * {@inheritDoc}
         */
static gchar**
skk_empty_dict_real_complete (SkkDict* base,
                              const gchar* midasi,
                              gint* result_length1)
{
	SkkEmptyDict * self;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** result;
#line 155 "dict.vala"
	self = (SkkEmptyDict*) base;
#line 155 "dict.vala"
	g_return_val_if_fail (midasi != NULL, NULL);
#line 156 "dict.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 156 "dict.vala"
	_tmp1_ = _tmp0_;
#line 156 "dict.vala"
	_tmp1__length1 = 0;
#line 156 "dict.vala"
	if (result_length1) {
#line 156 "dict.vala"
		*result_length1 = _tmp1__length1;
#line 1264 "dict.c"
	}
#line 156 "dict.vala"
	result = _tmp1_;
#line 156 "dict.vala"
	return result;
#line 1270 "dict.c"
}

SkkEmptyDict*
skk_empty_dict_construct (GType object_type)
{
	SkkEmptyDict * self = NULL;
#line 138 "dict.vala"
	self = (SkkEmptyDict*) skk_dict_construct (object_type);
#line 138 "dict.vala"
	return self;
#line 1281 "dict.c"
}

SkkEmptyDict*
skk_empty_dict_new (void)
{
#line 138 "dict.vala"
	return skk_empty_dict_construct (SKK_TYPE_EMPTY_DICT);
#line 1289 "dict.c"
}

static gboolean
skk_empty_dict_real_get_read_only (SkkDict* base)
{
	gboolean result;
	SkkEmptyDict* self;
#line 163 "dict.vala"
	self = (SkkEmptyDict*) base;
#line 164 "dict.vala"
	result = TRUE;
#line 164 "dict.vala"
	return result;
#line 1303 "dict.c"
}

static void
skk_empty_dict_class_init (SkkEmptyDictClass * klass,
                           gpointer klass_data)
{
#line 138 "dict.vala"
	skk_empty_dict_parent_class = g_type_class_peek_parent (klass);
#line 138 "dict.vala"
	((SkkDictClass *) klass)->reload = (void (*) (SkkDict*, GError**)) skk_empty_dict_real_reload;
#line 138 "dict.vala"
	((SkkDictClass *) klass)->lookup = (SkkCandidate** (*) (SkkDict*, const gchar*, gboolean, gint*)) skk_empty_dict_real_lookup;
#line 138 "dict.vala"
	((SkkDictClass *) klass)->complete = (gchar** (*) (SkkDict*, const gchar*, gint*)) skk_empty_dict_real_complete;
#line 138 "dict.vala"
	SKK_DICT_CLASS (klass)->get_read_only = (gboolean (*) (SkkDict*)) skk_empty_dict_real_get_read_only;
#line 138 "dict.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_skk_empty_dict_get_property;
#line 1322 "dict.c"
	/**
	         * {@inheritDoc}
	         */
#line 138 "dict.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_EMPTY_DICT_READ_ONLY_PROPERTY, skk_empty_dict_properties[SKK_EMPTY_DICT_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1328 "dict.c"
}

static void
skk_empty_dict_instance_init (SkkEmptyDict * self,
                              gpointer klass)
{
}

/**
     * Null implementation of Dict.
     */
static GType
skk_empty_dict_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SkkEmptyDictClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_empty_dict_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkEmptyDict), 0, (GInstanceInitFunc) skk_empty_dict_instance_init, NULL };
	GType skk_empty_dict_type_id;
	skk_empty_dict_type_id = g_type_register_static (SKK_TYPE_DICT, "SkkEmptyDict", &g_define_type_info, 0);
	return skk_empty_dict_type_id;
}

GType
skk_empty_dict_get_type (void)
{
	static volatile gsize skk_empty_dict_type_id__once = 0;
	if (g_once_init_enter (&skk_empty_dict_type_id__once)) {
		GType skk_empty_dict_type_id;
		skk_empty_dict_type_id = skk_empty_dict_get_type_once ();
		g_once_init_leave (&skk_empty_dict_type_id__once, skk_empty_dict_type_id);
	}
	return skk_empty_dict_type_id__once;
}

static void
_vala_skk_empty_dict_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	SkkEmptyDict * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SKK_TYPE_EMPTY_DICT, SkkEmptyDict);
#line 138 "dict.vala"
	switch (property_id) {
#line 138 "dict.vala"
		case SKK_EMPTY_DICT_READ_ONLY_PROPERTY:
#line 138 "dict.vala"
		g_value_set_boolean (value, skk_dict_get_read_only ((SkkDict*) self));
#line 138 "dict.vala"
		break;
#line 1377 "dict.c"
		default:
#line 138 "dict.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 138 "dict.vala"
		break;
#line 1383 "dict.c"
	}
}

GQuark
skk_skk_dict_error_quark (void)
{
	return g_quark_from_static_string ("skk-skk-dict-error-quark");
}

static GType
skk_skk_dict_error_get_type_once (void)
{
	static const GEnumValue values[] = {{SKK_SKK_DICT_ERROR_NOT_READABLE, "SKK_SKK_DICT_ERROR_NOT_READABLE", "not-readable"}, {SKK_SKK_DICT_ERROR_MALFORMED_INPUT, "SKK_SKK_DICT_ERROR_MALFORMED_INPUT", "malformed-input"}, {0, NULL, NULL}};
	GType skk_skk_dict_error_type_id;
	skk_skk_dict_error_type_id = g_enum_register_static ("SkkSkkDictError", values);
	return skk_skk_dict_error_type_id;
}

GType
skk_skk_dict_error_get_type (void)
{
	static volatile gsize skk_skk_dict_error_type_id__once = 0;
	if (g_once_init_enter (&skk_skk_dict_error_type_id__once)) {
		GType skk_skk_dict_error_type_id;
		skk_skk_dict_error_type_id = skk_skk_dict_error_get_type_once ();
		g_once_init_leave (&skk_skk_dict_error_type_id__once, skk_skk_dict_error_type_id);
	}
	return skk_skk_dict_error_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

